#include <iostream>

#include "./common.h"

using namespace std;

int test_num;

void Display1();
void Display2();
void Display3();
void Display4();
void Display5();
void Display6();
void Display7();
void Display8();
void Display9();
void Display10();
void Display11();
void Display12();

void Init() {
  glClearColor(1.0, 1.0, 1.0, 1.0);
}

void Display() {
  glClear(GL_COLOR_BUFFER_BIT);

  if (test_num == 1) {
    Display1();
  } else if (test_num == 2) {
    Display2();
  } else if (test_num == 3) {
    Display3();
  } else if (test_num == 4) {
    Display4();
  } else if (test_num == 5) {
    Display5();
  } else if (test_num == 6) {
    Display6();
  } else if (test_num == 7) {
    Display7();
  } else if (test_num == 8) {
    Display8();
  } else if (test_num == 9) {
    Display9();
  } else if (test_num == 10) {
    Display10();
  } else if (test_num == 11) {
    Display11();
  } else if (test_num == 12) {
    Display12();
  }

  glFlush();
}

void Keyboard(unsigned char key, int x, int y) {
  switch (key) {
    case 'q':
      exit(EXIT_SUCCESS);
      break;
  }
}

int main(int argc, char** argv) {
  if (argc < 2) {
    cout << "Usage: test testnum" << endl;
    return 0;
  }

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
  glutInitWindowSize(500, 500);
  glutInitWindowPosition(0, 0);
  glutCreateWindow("lecture 2");
  glutDisplayFunc(Display);
  glutKeyboardFunc(Keyboard);
  Init();

  test_num = atoi(argv[1]);

  glutMainLoop();
}

//--------------------------------------------------
// Test functions
//--------------------------------------------------

void Display1() {
  // Discuss cpplint

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What color is this?
  //   A) red
  //   B) green
  //   C) blue
  //   D) chartreuse
  glColor3f(0.0, 1.0, 0.0);
  glLineWidth(3.0);

  // What will this draw?
  //   A) square
  //   B) triangle
  //   C) circle
  glBegin(GL_LINE_LOOP);
  glVertex2f(-50.0, -50.0);
  glVertex2f(50.0, -50.0);
  glVertex2f(50.0, 50.0);
  glVertex2f(-50.0, 50.0);
  glEnd();

  gluErrorString(glGetError());
}

void Display2() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What color will the third vertex be?
  //   A) red
  //   B) green
  //   C) blue
  glColor3f(0.0, 1.0, 0.0);
  glLineWidth(3.0);
  glBegin(GL_LINE_LOOP);
  glVertex2f(-50.0, -50.0);
  glVertex2f(50.0, -50.0);
  glColor3f(1.0, 0.0, 0.0);
  glVertex2f(50.0, 50.0);
  glVertex2f(-50.0, 50.0);
  glEnd();

  gluErrorString(glGetError());
}

void Display3() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What width will the third edge be?
  //   A) 3.0
  //   B) 6.0
  //   C) 9.0
  glColor3f(0.0, 1.0, 0.0);
  glLineWidth(3.0);
  glBegin(GL_LINE_LOOP);
  glVertex2f(-50.0, -50.0);
  glVertex2f(50.0, -50.0);
  glLineWidth(6.0);
  glVertex2f(50.0, 50.0);
  glVertex2f(-50.0, 50.0);
  glEnd();

  gluErrorString(glGetError());

  // In the main() function is the following call:
  //  glutInitWindowSize(500, 500);
  // What will happen to the object if we change it to
  //  glutInitWindowSize(400, 400);
  //   A) it will shrink
  //   B) it will grow
  //   C) it will remain the same size

  // At the beginning of this function is the call
  //  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  // What will happen to the object if we change it to
  //  gluOrtho2D(-75.0, 75.0, -75.0, 75.0);
  //   A) it will shrink
  //   B) it will grow
  //   C) it will remain the same size

  // Consider the following calls:
  //  glutInitWindowSize(500, 500);
  //  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  // What are the window/device coordinates for the vertex
  //  glVertex3f(20, 80);
  //   A) (300, 50)
  //   B) (300, 450)
  //   C) (120, 180)
}

void Display4() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) a square
  //   B) a triangle
  //   C) a C
  //   D) none of the above
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3.0);
  glBegin(GL_LINE_STRIP);
  glVertex2f(-50.0, -50.0);
  glVertex2f(50.0, -50.0);
  glVertex2f(50.0, 50.0);
  glVertex2f(-50.0, 50.0);
  glEnd();
}

void Display5() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) a square
  //   B) a triangle
  //   C) a C
  //   D) none of the above
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glBegin(GL_LINES);
  glVertex2f(-50.0, -50.0);
  glVertex2f(50.0, -50.0);
  glVertex2f(50.0, 50.0);
  glVertex2f(-50.0, 50.0);
  glEnd();
}

void Display6() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) square
  //   B) triangle
  //   C) star
  //   D) none of the above
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
  glBegin(GL_POLYGON);
  glVertex2f(-50.0, -50.0);
  glVertex2f(0.0, 50.0);
  glVertex2f(50.0, -50.0);
  glVertex2f(-75.0, 20.0);
  glVertex2f(75.0, 20.0);
  glEnd();
}

void Display7() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) filled square
  //   B) filled triangle
  //   C) filled star
  //   D) none of the above
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glBegin(GL_POLYGON);
  glVertex2f(-50.0, -50.0);
  glVertex2f(0.0, 50.0);
  glVertex2f(50.0, -50.0);
  glVertex2f(-75.0, 20.0);
  glVertex2f(75.0, 20.0);
  glEnd();
}

void Display8() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) wireframe triangle
  //   B) filled triangle
  //   C) nothing
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glPolygonMode(GL_FRONT, GL_LINE);
  glPolygonMode(GL_BACK, GL_FILL);
  glBegin(GL_TRIANGLES);
  glVertex2f(-50.0, -50.0);
  glVertex2f(50.0, -50.0);
  glVertex2f(0.0, 50.0);
  glEnd();
}

void Display9() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) 1 triangle
  //   B) 2 triangles
  //   C) 4 triangles
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
  glBegin(GL_TRIANGLES);
  glVertex2f(-50.0, 0.0);
  glVertex2f(-50.0, 50.0);
  glVertex2f(0.0, 0.0);
  glVertex2f(0.0, 50.0);
  glVertex2f(50.0, 0.0);
  glVertex2f(50.0, 50.0);
  glEnd();

  // try GL_TRIANGLE_STRIP
  // change colors mid-stream
}

void Display10() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) 1 triangle
  //   B) 2 triangles
  //   C) 4 triangles
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
  glBegin(GL_TRIANGLE_STRIP);
  glVertex2f(-50.0, 0.0);
  glVertex2f(-50.0, 50.0);
  glVertex2f(0.0, 0.0);
  glVertex2f(0.0, 50.0);
  glVertex2f(50.0, 0.0);
  glVertex2f(50.0, 50.0);
  glEnd();
}

void Display11() {
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-100.0, 100.0, -100.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

  // What will the following draw?
  //   A) 2 filled triangles
  //   B) 2 wireframe triangles
  //   C) 1 filled, 1 wireframe
  glColor3f(0.0, 0.0, 0.0);
  glLineWidth(3);
  glPolygonMode(GL_FRONT, GL_LINE);
  glPolygonMode(GL_BACK, GL_FILL);
  glBegin(GL_TRIANGLE_FAN);
  glVertex2f(0.0, 0.0);
  glVertex2f(50.0, 0.0);
  glVertex2f(50.0, 50.0);
  glVertex2f(75.0, 25.0);
  glEnd();
}

void Display12() {
}
